diff --git a/xen/arch/arm/Makefile b/xen/arch/arm/Makefile
index 4970641..5cc4b37 100644
--- a/xen/arch/arm/Makefile
+++ b/xen/arch/arm/Makefile
@@ -34,6 +34,7 @@ obj-y += shutdown.o
 obj-y += traps.o
 obj-y += vgic.o vgic-v2.o
 obj-$(CONFIG_ARM_64) += vgic-v3.o
+obj-$(CONFIG_ARM_64) += vgic-v3-its.o
 obj-y += vtimer.o
 obj-y += vuart.o
 obj-y += hvm.o
diff --git a/xen/arch/arm/gic-v3-its.c b/xen/arch/arm/gic-v3-its.c
index fa88a75..e495d4d 100644
--- a/xen/arch/arm/gic-v3-its.c
+++ b/xen/arch/arm/gic-v3-its.c
@@ -37,6 +37,7 @@
 #include <asm/gic.h>
 #include <asm/gic_v3_defs.h>
 #include <asm/gic-its.h>
+#include <asm/vits.h>
 #include <xen/log2.h>
 
 #define its_print(lvl, fmt, ...)                                      \
@@ -86,8 +87,16 @@ struct its_node {
     u64                     flags;
     u32                     ite_size;
     struct dt_device_node   *dt_node;
+    u8                      eventID_bits;
+    u8                      devID_bits;
 };
 
+/* Contains common and collective data of all the its nodes. */
+static struct {
+    u8 eventID_bits;
+    u8 devID_bits;
+} its_data;
+
 #define ITS_ITT_ALIGN    SZ_256
 
 static LIST_HEAD(its_nodes);
@@ -812,6 +821,8 @@ int its_add_device(u32 devid, u32 nr_ites, struct dt_device_node *dt_its)
         goto err_unlock;
     }
 
+    ASSERT(dev->event_map.nr_lpis < (1 << dev->its->eventID_bits));
+
     BUG_ON(its_insert_device(dev));
     spin_unlock(&rb_its_dev_lock);
 
@@ -915,6 +926,14 @@ int its_assign_device(struct domain *d, u32 vdevid, u32 pdevid)
     return 0;
 }
 
+static void update_its_data(struct its_node *its)
+{
+    if ( its_data.eventID_bits < its->eventID_bits )
+        its_data.eventID_bits = its->eventID_bits;
+    if ( its_data.devID_bits < its->devID_bits )
+        its_data.devID_bits = its->devID_bits;
+}
+
 /*
  * We allocate 64kB for PROPBASE. That gives us at most 64K LPIs to
  * deal with (one configuration byte per interrupt). PENDBASE has to
@@ -1360,6 +1379,9 @@ static int its_probe(struct dt_device_node *node)
     its->phys_size = its_size;
     typer = readl_relaxed(its_base + GITS_TYPER);
     its->ite_size = ((typer >> 4) & 0xf) + 1;
+    its->eventID_bits = GITS_TYPER_IDBITS(typer);
+    its->devID_bits = GITS_TYPER_DEVBITS(typer);
+    update_its_data(its);
 
     its->cmd_base = xzalloc_bytes(ITS_CMD_QUEUE_SZ);
     if ( !its->cmd_base )
@@ -1451,6 +1473,7 @@ int its_cpu_init(void)
 
 int __init its_init(struct rdist_prop *rdists)
 {
+    struct its_node *its;
     struct dt_device_node *np = NULL;
 
     static const struct dt_device_match its_device_ids[] __initconst =
@@ -1473,6 +1496,16 @@ int __init its_init(struct rdist_prop *rdists)
     its_alloc_lpi_tables();
     its_lpi_init(rdists->id_bits);
 
+    its = list_first_entry(&its_nodes, struct its_node, entry);
+    /*
+     * As per vITS design spec, Xen exposes only one virtual ITS per domain.
+     * This simplifies vITS command model. I.e simplifies processing global
+     * ITS commands which does not have device ID on platform having more
+     * than one physical ITS.
+     */
+    vits_setup_hw(its_data.devID_bits, its_data.eventID_bits,
+                  its->phys_base, its->phys_size);
+
     return 0;
 }
 
diff --git a/xen/arch/arm/vgic-v3-its.c b/xen/arch/arm/vgic-v3-its.c
index bdcd9f1..36e6385 100644
--- a/xen/arch/arm/vgic-v3-its.c
+++ b/xen/arch/arm/vgic-v3-its.c
@@ -70,6 +70,26 @@ static void dump_cmd(const its_cmd_block *cmd)
 static void dump_cmd(const its_cmd_block *cmd) { }
 #endif
 
+static struct {
+    bool_t enabled;
+    uint8_t devID_bits;
+    uint8_t eventID_bits;
+    /* GITS physical base */
+    paddr_t phys_base;
+    /* GITS physical size */
+    unsigned long phys_size;
+} vits_hw;
+
+void vits_setup_hw(uint8_t devID_bits, uint8_t eventID_bits,
+                   paddr_t phys_base, unsigned long phys_size)
+{
+    vits_hw.enabled = 1;
+    vits_hw.devID_bits = devID_bits;
+    vits_hw.eventID_bits = eventID_bits;
+    vits_hw.phys_base = phys_base;
+    vits_hw.phys_size = phys_size;
+}
+
 static inline uint16_t vits_get_max_collections(struct domain *d)
 {
     /*
@@ -838,6 +858,7 @@ int vits_domain_init(struct domain *d)
     }
 
     ASSERT(is_hardware_domain(d));
+    ASSERT(vits_hw.enabled);
 
     d->arch.vgic.vits = xzalloc(struct vgic_its);
     if ( !d->arch.vgic.vits )
diff --git a/xen/include/asm-arm/vits.h b/xen/include/asm-arm/vits.h
index 5063c18..3579395 100644
--- a/xen/include/asm-arm/vits.h
+++ b/xen/include/asm-arm/vits.h
@@ -93,6 +93,8 @@ int vits_get_vitt_entry(struct domain *d, uint32_t devid, uint32_t event,
                         struct vitt *entry);
 int vits_get_vdevice_entry(struct domain *d, uint32_t devid,
                            struct vdevice_table *entry);
+void vits_setup_hw(uint8_t dev_bits, uint8_t eventid_bits,
+                   paddr_t base, unsigned long size);
 
 #endif /* __ASM_ARM_VITS_H__ */
 /*